unit fade_gif;
interface
var
  vram_pos,                     {aktuelle Position im VGA-Ram}
  rest, errornr:word;           {restliche Bytes im Hauptspeicher und Fehler}
  helpvscreen,Vscreen:Pointer;              {Zeiger auf Quellbereich fr p13_2_modex}
  palette:Array[0..256*3-1] of Byte; {VGA - Palette}
  gifname:String;               {Name, erweitert um #0}

  procedure fadein(s: string);
  procedure g_show(s: string);
  Procedure LoadGif(GName:String);
  Procedure SetPal;             {kopiert Palette in VGA-DAC}
  Procedure GetPal;             {liest Palette aus VGA-DAC aus}
  Procedure Fade_Out;           {blendet Bild aus}
  procedure waitretrace;

implementation
uses crt;
var i,j:word;
    zielpal:Array[0..767] of Byte;

  Procedure SetPal;external;
  Procedure GetPal;external;
  Procedure Fade_Out;external;
  {$l modexlib}
  Procedure ReadGif;external;   {eigentlicher Gif-Loader, kompl. in Asm}
  {$l gif}

  Procedure LoadGif;
  {Ldt Gif-Datei "GName.gif" in vscreen}
  Begin
    If pos('.',gname) = 0 then  {evtl. Endung ".gif" anhngen}
      gname:=gname+'.gif';
    Gifname:=GName+#0;;         {ASCIIZ - String erzeugen}
    vram_pos:=0;                {im VGA-Ram an Offset 0 beginnen}
    ReadGif;                    {und Bild laden}
    If Errornr <> 0 Then        {bei Fehler abbrechen}
      Halt(Errornr);
    SetPal;                     {geladene Palette setzen}
  End;

procedure waitretrace; assembler;
asm
  mov dx, $3da
  @1: in al, dx
  test al, 8
  jz @1
  @2:in al,dx
  test al,8
  jnz @2
end;

Procedure Screen_Off;
Begin
  Port[$3c4]:=1;                {Register 1 des TS (TS Mode) selektieren}
  Port[$3c5]:=Port[$3c5] or 32; {Bit 5 (Screen Off) setzen}
End;

Procedure Screen_On;
Begin
  Port[$3c4]:=1;                {Register 1 des TS (TS Mode) selektieren}
  Port[$3c5]:=Port[$3c5] and not 32;  {Bit 5 (Screen Off lschen}
End;

Procedure Fade_in(ZPal:Array of Byte);
Begin
  For j:=0 to 63 do Begin       {64 Durchlufe, um komplett zu faden}
    For i:=0 to 767 do          {768 Farbwerte berechnen}
      If Palette[i] < ZPal[i]   {aktueller Wert noch kleiner als Zielwert ?}
        Then Inc(Palette[i]);   {dann erhhen}
    WaitRetrace;                {Synchronisation}
    SetPal;                     {berechnete Palette setzen}
  End;
End;

procedure fadein(s:string);
begin
  GetPal;                       {"Palette" mit aktuelle DAC-Palette laden}
  asm mov ax,13h; int 10h End;  {Mode 13h ein (oder anderer Grafikmodus)}
  screen_off;
  LoadGif(s);             {Hintergrund-Bild laden}
  Move(vscreen^,Ptr($a000,0)^,64000); {und auf Screen}
  Move(Palette,Zielpal,768);    {Palette sichern}
  FillChar(Palette,768,0);      {alte Palette lschen}
  SetPal;                       {und setzen}
  screen_on;
  fade_in(Zielpal);             {Bild auf Zielpal (originale Palette) faden}
End;

procedure g_show(s:string);
begin
  asm mov ax,13h; int 10h End;  {Mode 13h ein (oder anderer Grafikmodus)}
  LoadGif(s);             {Hintergrund-Bild laden}
  Move(vscreen^,Ptr($a000,0)^,64000); {und auf Screen}
End;

Begin
  errornr:=0;                   {normalerweise kein Fehler}
End.